#include <stdbool.h>
#include <stdio.h>
// TODO: Add any other needed imports

// TODO: Add file constants for line and pattern length

// Copies a string (up to max length)
// Optionally converts the copied string to lowercase
// Params:
//  - copy_to:    The string/buffer to copy to
//  - copy_from:  The null-terminated string to copy from
//  - max_length: The max characters to copy over (including null terminator)
//  - lowercase:  Whether to convert to lowercase after copying
void copy_string(char *copy_to, char *copy_from, int max_length,
                 bool lowercase);

// Prints all lines in a file that match the pattern
// Params:
//  - file:              the file to check for results
//  - pattern:           the pattern to look for in each line
//  - ignore_case:       whether to ignore case when using the pattern
//  - print_line_number: whether to print the line number for each matching line
void print_matches_in_file(FILE *file, char *pattern,
                           bool ignore_case, bool print_line_number);

// Loops through a list of files and prints matches to the pattern for each
// Params:
//  - num_files:         number of files in the list
//  - filename_list:     list of filenames to check
//  - pattern:           the pattern to look for in each line
//  - ignore_case:       whether to ignore case when using the pattern
//  - print_line_number: whether to print the line number for each matching line
void print_all_matches(int num_files, char **filename_list, char *pattern,
                       bool ignore_case, bool print_line_number);

// Print the usage of the program
// Params:
//  - program_name: the name of the program being run (argv[0])
void usage(char *program_name);

// Main entry point of the function
// Parses the input into flags, pattern, and files
// Params:
//  - argc: The number of arguments provided
//  - argv: The list of arguments provided
// Returns the exit status
int main(int argc, char **argv);


// TODO: Fill in functions below

void copy_string(char *copy_to, char *copy_from, int max_length,
                 bool lowercase) {
    // TODO
}

void print_matches_in_file(FILE *file, char *pattern,
                           bool ignore_case, bool print_line_number) {
    // TODO
}


void print_all_matches(int num_files, char **filename_list, char *pattern,
                       bool ignore_case, bool print_line_number) {
    // TODO
}


void usage(char *program_name) {
    printf("Usage: %s [OPTIONS] pattern file...\n", program_name);
}

int main(int argc, char **argv) {
    // TODO
}
